<?php

namespace App\Http\Controllers;

use App\Models\Dia;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class DiaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Dia::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Dia())->getFillable());
        $dia = Dia::create($payload);

        return response()->json([
            'success' => true,
            'data' => $dia,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Dia $dia): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $dia,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Dia $dia): JsonResponse
    {
        $payload = $request->only((new Dia())->getFillable());
        $dia->update($payload);

        return response()->json([
            'success' => true,
            'data' => $dia,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Dia $dia): JsonResponse
    {
        $dia->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}